-- LDAP-NIS ASN1 Schema Definitions
-- VeRsIoN= 1.0
-- CoPyRiGhT=(c) Copyright 2000, Novell, Inc.  All rights reserved

-- Object ID (OID) is registered with Internal Schema Registration
-- as of 14 June, 2000
--
-- OIDs are defined as follows:
--   joint-iso-ccitt(2) country(16) us(840) organization(1)
--   Novell(113719) applications(1) UAM (196)
-- Registered Prefix: uamPosix
-- uamPosix Attribute Type 4
-- uamPosix Attribute Syntax 5
-- uamPosix Object Class 6
-- The last digit is the number(0 through...)

-- We also define attributes and classes from RFC2307.
-- Their OIDs are defined as
-- iso(1) org(3) dod(6) internet(1) directory(1) nisschema(1)
-- nisschema Attribute Type 1
-- nisschema Object Class 2
-- The last digit is the number (0 through...)
--------------------------------------------------------------------------

namSchemaExtentions {2 16 840 1 113719 1 196} DEFINITIONS ::=
BEGIN

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.0 NAME 'uidNumber' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"uidNumber" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 0}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.1 NAME 'gidNumber' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"gidNumber" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 1}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.2 NAME 'gecos' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15{64512} SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--Note:Syntax needs to be reviewed
--------------------------------------------------------------------------
"gecos" ATTRIBUTE ::=
{
	SyntaxID SYN_CI_STRING, 
	Flags {DS_SINGLE_VALUED_ATTR},
        LowerBound 2,
	ASN1ObjID {1 3 6 1 1 1 1 2}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.3 NAME 'homeDirectory' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26{64512} SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--Note:Syntax needs to be reviewed
--------------------------------------------------------------------------
"homeDirectory" ATTRIBUTE ::=
{
	SyntaxID SYN_CE_STRING, 
	Flags {DS_SINGLE_VALUED_ATTR},
        LowerBound 2,
	ASN1ObjID {1 3 6 1 1 1 1 3}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.4 NAME 'loginShell' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26{64512} SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--Note:Syntax needs to be reviewed
--------------------------------------------------------------------------
"loginShell" ATTRIBUTE ::=
{
	SyntaxID SYN_CE_STRING, 
	Flags {DS_SINGLE_VALUED_ATTR},
        LowerBound 2,
	ASN1ObjID {1 3 6 1 1 1 1 4}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.5 NAME 'shadowLastChange' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowLastChange" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 5}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.6 NAME 'shadowMin' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowMin" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 6}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.7 NAME 'shadowMax' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowMax" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 7}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.8 NAME 'shadowWarning' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowWarning" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 8}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.9 NAME 'shadowInactive' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowInactive" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 9}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.10 NAME 'shadowExpire' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowExpire" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 10}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.11 NAME 'shadowFlag' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.27 SINGLE-VALUE X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"shadowFlag" ATTRIBUTE ::=
{
	SyntaxID SYN_INTEGER, 
	Flags {DS_SINGLE_VALUED_ATTR},
	ASN1ObjID {1 3 6 1 1 1 1 11}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 1.3.6.1.1.1.1.12 NAME 'memberUid' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26{64512} X-NDS_NOT_SCHED_SYNC_IMMEDIATE '1' )
--------------------------------------------------------------------------
"memberUid" ATTRIBUTE ::=
{
	SyntaxID SYN_CE_STRING, 
	ASN1ObjID {1 3 6 1 1 1 1 12}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 2.16.840.1.113719.1.196.4.0 NAME 'uamPosixWorkstationList' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.12 )
--------------------------------------------------------------------------
"uamPosixWorkstationList" ATTRIBUTE ::=
{
	SyntaxID SYN_DIST_NAME, 
	Flags {DS_SYNC_IMMEDIATE},
	ASN1ObjID {2 16 840 1 113719 1 196 4 0}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 2.16.840.1.113719.1.196.4.1 NAME 'uamPosixWorkstationContexts' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.12 )
--------------------------------------------------------------------------
"uamPosixWorkstationContexts" ATTRIBUTE ::=
{
	SyntaxID SYN_DIST_NAME, 
	Flags {DS_SYNC_IMMEDIATE},
	ASN1ObjID {2 16 840 1 113719 1 196 4 1}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 2.16.840.1.113719.1.196.4.2 NAME 'uamPosixSalt' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26{12} SINGLE-VALUE X-NDS_LOWER_BOUND '2')
--Note:Syntax needs to be reviewed
--------------------------------------------------------------------------
"uamPosixSalt" ATTRIBUTE ::=
{
	SyntaxID SYN_CE_STRING, 
	Flags {DS_SINGLE_VALUED_ATTR,DS_SIZED_ATTR,DS_SYNC_IMMEDIATE},
        LowerBound   2,
	UpperBound   12,
	ASN1ObjID {2 16 840 1 113719 1 196 4 2}
}
--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: attributetypes
--attributeTypes: ( 2.16.840.1.113719.1.196.4.3 NAME 'uamPosixPAMServiceExcludeList' DESC 'Standard Attribute' SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 )--------------------------------------------------------------------------
"uamPosixPAMServiceExcludeList" ATTRIBUTE ::=
{
	SyntaxID SYN_CE_STRING, 
	Flags {DS_SYNC_IMMEDIATE},
	ASN1ObjID {2 16 840 1 113719 1 196 4 3}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 1.3.6.1.1.1.2.0 NAME 'posixAccount' DESC 'Standard ObjectClass' AUXILIARY MUST (cn $ uid $ uidNumber $ gidNumber $ homeDirectory ) MAY (loginShell $ gecos $ description ) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"posixAccount" OBJECT-CLASS ::=
{
	Operation	ADD,
	Flags		{DS_AUXILIARY_CLASS},
	MustContain	{"CN", "uniqueID", "uidNumber", "gidNumber", "homeDirectory"},
	MayContain	{"loginShell", "gecos", "Description"},
	ASN1ObjID 	{1 3 6 1 1 1 2 0}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 1.3.6.1.1.1.2.1 NAME 'shadowAccount' DESC 'Standard ObjectClass' AUXILIARY MUST uid MAY (shadowLastChange $ shadowMin $ shadowMax $ shadowWarning $ shadowInactive $ shadowExpire $ shadowFlag $ description ) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"shadowAccount" OBJECT-CLASS ::=
{
	Operation	ADD,
	Flags		{DS_AUXILIARY_CLASS},
	MustContain	{"uniqueID"},
	MayContain	{"shadowLastChange", "shadowMin", "shadowMax", "shadowWarning", "shadowInactive", "shadowExpire", "shadowFlag", "Description"},
	ASN1ObjID 	{1 3 6 1 1 1 2 1}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 1.3.6.1.1.1.2.2 NAME 'posixGroup' DESC 'Standard ObjectClass' AUXILIARY MUST (cn $ gidNumber ) MAY (memberUid $ description ) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"posixGroup" OBJECT-CLASS ::=
{
	Operation	ADD,
	Flags		{DS_AUXILIARY_CLASS},
	MustContain	{"CN", "gidNumber"},
	MayContain	{"memberUid", "Description"},
	ASN1ObjID 	{1 3 6 1 1 1 2 2}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 2.16.840.1.113719.1.196.6.0 NAME 'uamPosixWorkstation' DESC 'Standard ObjectClass' SUP top STRUCTURAL MUST cn MAY (groupMembership $ privateKey $ publicKey ) X-NDS_NAMING 'cn' X-NDS_CONTAINMENT ('organization' 'organizationalUnit' 'domain' ) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"uamPosixWorkstation" OBJECT-CLASS ::=
{
	Operation 	ADD,
	Flags	   	{DS_EFFECTIVE_CLASS},
	SubClassOf	{"TOP"},
	ContainedBy	{"Organization", "Organizational Unit", "domain" },
	NamedBy	        {"CN"},
	MustContain	{"CN"},
	MayContain 	{"Group Membership", "Private Key", "Public Key"},
	ASN1ObjID	{2 16 840 1 113719 1 196 6 0}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 2.16.840.1.113719.1.196.6.1 NAME 'uamPosixConfig' DESC 'Standard ObjectClass' SUP top STRUCTURAL MUST cn MAY (description $ uamPosixWorkstationContexts ) X-NDS_NAMING 'cn' X-NDS_CONTAINMENT ('organization' 'organizationalUnit' 'domain' ) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"uamPosixConfig" OBJECT-CLASS ::=
{
	Operation 	ADD,
	Flags	   	{DS_EFFECTIVE_CLASS},
	SubClassOf	{"TOP"},
	ContainedBy	{"Organization", "Organizational Unit", "domain" },
	NamedBy	        {"CN"},
	MustContain	{"CN"},
	MayContain 	{"description", "uamPosixWorkstationContexts"},
	ASN1ObjID	{2 16 840 1 113719 1 196 6 1}
}
--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 2.16.840.1.113719.1.196.6.2 NAME 'uamPosixUser' DESC 'Standard ObjectClass' AUXILIARY MAY (uamPosixSalt $ uamPosixPAMServiceExcludeList) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"uamPosixUser" OBJECT-CLASS ::=
{
	Operation 	ADD,
	Flags		{DS_AUXILIARY_CLASS},
	MayContain 	{"uamPosixSalt", "uamPosixPAMServiceExcludeList"},
	ASN1ObjID	{2 16 840 1 113719 1 196 6 2}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 2.16.840.1.113719.1.196.6.3 NAME 'uamPosixGroup' DESC 'Standard ObjectClass' AUXILIARY MAY (uamPosixWorkstationList $ uamPosixPAMServiceExcludeList) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"uamPosixGroup" OBJECT-CLASS ::=
{
	Operation 	ADD,
	Flags		{DS_AUXILIARY_CLASS},
	MayContain 	{"uamPosixWorkstationList", "uamPosixPAMServiceExcludeList"},
	ASN1ObjID	{2 16 840 1 113719 1 196 6 3}
}
--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 2.16.840.1.113719.1.196.6.2 NAME 'uamPosixUser' DESC 'Standard ObjectClass' AUXILIARY MAY (uamPosixSalt $ uamPosixPAMServiceExcludeList) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"uamPosixUser" OBJECT-CLASS ::=
{
	Operation 	MODIFY,
	Flags		{DS_AUXILIARY_CLASS},
	MayContain 	{"uamPosixSalt", "uamPosixPAMServiceExcludeList"},
	ASN1ObjID	{2 16 840 1 113719 1 196 6 2}
}

--------------------------------------------------------------------------
--dn: cn=schema
--changetype: modify
--add: objectclasses
--objectClasses: ( 2.16.840.1.113719.1.196.6.3 NAME 'uamPosixGroup' DESC 'Standard ObjectClass' AUXILIARY MAY (uamPosixWorkstationList $ uamPosixPAMServiceExcludeList) X-NDS_NOT_CONTAINER '1' )
--------------------------------------------------------------------------
"uamPosixGroup" OBJECT-CLASS ::=
{
	Operation 	MODIFY,
	Flags		{DS_AUXILIARY_CLASS},
	MayContain 	{"uamPosixWorkstationList", "uamPosixPAMServiceExcludeList"},
	ASN1ObjID	{2 16 840 1 113719 1 196 6 3}
}

END
